export type Options = {
    root: Element;
    idName: (name: string) => boolean;
    className: (name: string) => boolean;
    tagName: (name: string) => boolean;
    attr: (name: string, value: string) => boolean;
    seedMinLength: number;
    optimizedMinLength: number;
    threshold: number;
    maxNumberOfTries: number;
    optimized: boolean;
};
/**
 * Gets a CSS selector for a given element. Will default to the element's tag name if there are no class name or id.
 * Source: https://github.com/antonmedv/finder
 */
export declare function getElementSelector(input: Element, options?: Partial<Options>): string;
export declare function getSimpleSelector(input: Element): string;
export declare function getElementSelectorNew(input: Element, options?: Partial<Options>): string;
